/*
PC-9801tbs[fBXNBIOSgĂ݂Tv
tbs[fBXÑZN^V[PX𒲂ׂB
FDC̓𐳊mɍČPC-9801G~[^͏Ȃ̂ŁAG~[^œmFꍇ͒ӂvB
LSI C-86 Ver.3.30 Hŗp
make ŃRpCł܂
lcc -o readsseq.exe readsseq.c diskbios.c ̂悤ɂăRpCĂǂ

̃\[XR[h CC0 pubNEhC񋟂łB
https://creativecommons.org/publicdomain/zero/1.0/deed.ja

2016N129  kyoutan.jpn.org
2016N618 R}hChCuƃgbNIׂ悤ɂ
*/
#include <stdio.h>
#include <stdlib.h>
#include "diskbios.h"

#define SECTMAX   32 /*őZN^ 1ZN^256oCg̎26Ȃ̂ŗ]T32炢*/
#define BUFFSIZE  (8*1024)
unsigned char BUFF[BUFFSIZE];

void usage(void)
{
    puts("READSSEQ tbs[fBXN̎wgbÑZN^̕т\ ");
    puts("");
    puts("READSSEQ <hCuԍ> [<V_ԍ>] [<wbhԍ>]");
}

int main(int argc, char* argv[])
{
    unsigned short count,startpos;
    unsigned char drive,mod,c,h;
    unsigned char sechead,seccount;

    drive=0;    /*hCuԍ 0-3*/
    c=0;        /*V_ԍ*/
    h=0;        /*wbhԍ 0-1*/

    if(2 > argc) {usage(); return FALSE;}
    if(1 < argc) drive = atoi(argv[1]);
    if(2 < argc)     c = atoi(argv[2]);
    if(3 < argc)     h = atoi(argv[3]);
    if(3 < drive) {usage(); return FALSE;}
    if(82 < c)    {usage(); return FALSE;}
    if(1 < h)     {usage(); return FALSE;}
    printf("DRIVE:%d C:%d H:%d \n", drive, c, h);

    /* 0V_Ɉړ */
    if(! track00(FD2HD | drive))
    {
        /*G[*/
        puts("RECALIBRATE ERROR");
        return FALSE;
    }

    /* fBXÑ^Cv𒲂ׂ FM/MFM 2DD/2HD */
    if(! (mod=sectsence(FD2HD | drive, c, h)))
    {
        puts("ID read error");
        return FALSE;
    }

    if(0x80 & mod) printf("2HD ");
    else printf("2DD ");
    drive = drive | (FD2HD & mod);  /* hCuԍ 2HD/2DD ̎wǉ */

    if(0x40 & mod) printf("MFM ");
    else printf("FM ");
    mod = FDMFM & mod;

    /*READDIAG Ő擪ZN^̔ԍ𒲂ׂ*/
    if(!secthead(drive, mod, h, BUFF))
    {
        puts(errmsg(BUFF[0]));
        return FALSE;
    }
    sechead=BUFF[0];    /*擪̃ZN^ԍ*/
    printf(" head of the sector : %d \n", sechead);

    /*READID 1gbÑZN^ID𒲂ׂ*/
    for(count = 0; count != (SECTMAX * 2); count++) /*2{̑厖*/
    {
        if(! readid(drive, mod, h, &BUFF[count * 4]))
        {
            printf("ID read error %d ", count);
            puts(errmsg(BUFF[0]));
            return FALSE;
        }
    }

    /*1gbNɉZN^邩*/
    for(seccount = 1; seccount != (SECTMAX - 1); seccount++)
    {
        if(BUFF[2] == BUFF[(seccount * 4) + 2]) break;
    }
    printf("%d secter/track   ", seccount);

    /*ׂẴZN^R[hv邩*/
    for(count = 0; count != seccount; count++)
    {
        if(BUFF[3] != BUFF[(count * 4) + 3])
        {
            /*vȂ*/
            puts("\nUnusual format : Sector length is not unified");
            return FALSE;
        }
    }
    printf("%d byte/sec \n", sectlength(BUFF[3]));

    /*擪珇Ƀobt@𐮓*/
    /*擪܂œǂݔ΂*/
    for(count=0; count != (SECTMAX - 1); count++)
    {
        if(sechead == BUFF[(count * 4) + 2]) break;
    }
    startpos = count * 4;
    /*obt@Rs[ iځj*/
    for(count=0; count != (seccount * 4); count++)
    {
        BUFF[count] = BUFF[startpos + count];
    }

    /*擪ZN^ID\*/
    puts(" C  H  R  N");
    for(count = 0 ; count != (seccount * 4); count += 4)
    {
        printf("%2d %2d %2d %2d \n", BUFF[count + 0]
                                   , BUFF[count + 1]
                                   , BUFF[count + 2]
                                   , BUFF[count + 3]);
    }

    return TRUE;
}
